Date cell type
Display, format, sort, and filter dates correctly by using the date cell type.
The date cell type provides a date picker for selecting and displaying dates. It validates input against a configurable date format.
Overview
The date cell type lets you treat cell values as dates: format how they are displayed, validate input, and use an interactive date picker in the editor. Handsontable supports two configurations: the object-style configuration using the native Intl.DateTimeFormat API (recommended), and a string-style configuration using Moment.js (deprecated).
Date cell type demo
In the following demo, multiple columns use the date cell type with different formatting styles:
- Product date: Date with short style formatting
- Payment date: Customized date formatting
- Registration date: Customized date formatting with weekday, month, day, year
import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.registerAllModules();
const container = document.querySelector('#example1');const dropdown = document.querySelector('#localeDropdown');const trigger = document.querySelector('#localeTrigger');const menu = document.querySelector('#localeMenu');const label = document.querySelector('#localeLabel');32 collapsed lines
const data = [ { car: 'Mercedes A 160', product_date: '2002-06-15', payment_date: '2002-05-20', registration_date: '2002-07-01', }, { car: 'Citroën C4 Coupe', product_date: '2007-03-22', payment_date: '2007-02-28', registration_date: '2007-04-10', }, { car: 'Audi A4 Avant', product_date: '2011-09-08', payment_date: '2011-08-15', registration_date: '2011-09-20', }, { car: 'Opel Astra', product_date: '2012-01-30', payment_date: '2012-01-10', registration_date: '2012-02-14', }, { car: 'BMW 320i Coupe', product_date: '2004-11-12', payment_date: '2004-10-20', registration_date: '2004-12-01', },];
const hot = new Handsontable(container, { data, colHeaders: ['Car', 'Product date', 'Payment date', 'Registration date'],32 collapsed lines
columns: [ { type: 'text', data: 'car', }, { type: 'intl-date', data: 'product_date', dateFormat: { dateStyle: 'short', }, }, { type: 'intl-date', data: 'payment_date', dateFormat: { month: 'long', day: 'numeric', year: 'numeric', }, }, { type: 'intl-date', data: 'registration_date', dateFormat: { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric', }, }, ], columnSorting: true, filters: true, dropdownMenu: true, height: 'auto', licenseKey: 'non-commercial-and-evaluation', autoWrapRow: true, autoWrapCol: true,});
// Handle dropdown toggletrigger.addEventListener('click', () => { const isOpen = !menu.hidden;
menu.hidden = isOpen; trigger.setAttribute('aria-expanded', String(!isOpen));});
// Handle locale selectionmenu.addEventListener('click', (e) => { const item = e.target.closest('li[data-value]');
if (item) { label.textContent = item.textContent.trim(); menu.querySelectorAll('li').forEach((li) => li.setAttribute('aria-selected', 'false')); item.setAttribute('aria-selected', 'true'); menu.hidden = true; trigger.setAttribute('aria-expanded', 'false'); hot.updateSettings({ locale: item.dataset.value }); }});
// Close dropdown when clicking outsidedocument.addEventListener('click', (e) => { if (!dropdown.contains(e.target)) { menu.hidden = true; trigger.setAttribute('aria-expanded', 'false'); }});
// Close dropdown on Escape keydocument.addEventListener('keydown', (e) => { if (e.key === 'Escape' && !menu.hidden) { menu.hidden = true; trigger.setAttribute('aria-expanded', 'false'); trigger.focus(); }});import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.registerAllModules();
const container = document.querySelector('#example1')!;const dropdown = document.querySelector('#localeDropdown')!;const trigger = document.querySelector('#localeTrigger')!;const menu = document.querySelector('#localeMenu')!;const label = document.querySelector('#localeLabel')!;32 collapsed lines
const data = [ { car: 'Mercedes A 160', product_date: '2002-06-15', payment_date: '2002-05-20', registration_date: '2002-07-01', }, { car: 'Citroën C4 Coupe', product_date: '2007-03-22', payment_date: '2007-02-28', registration_date: '2007-04-10', }, { car: 'Audi A4 Avant', product_date: '2011-09-08', payment_date: '2011-08-15', registration_date: '2011-09-20', }, { car: 'Opel Astra', product_date: '2012-01-30', payment_date: '2012-01-10', registration_date: '2012-02-14', }, { car: 'BMW 320i Coupe', product_date: '2004-11-12', payment_date: '2004-10-20', registration_date: '2004-12-01', },];
const hot = new Handsontable(container, { data, colHeaders: ['Car', 'Product date', 'Payment date', 'Registration date'],32 collapsed lines
columns: [ { type: 'text', data: 'car', }, { type: 'intl-date', data: 'product_date', dateFormat: { dateStyle: 'short', }, }, { type: 'intl-date', data: 'payment_date', dateFormat: { month: 'long', day: 'numeric', year: 'numeric', }, }, { type: 'intl-date', data: 'registration_date', dateFormat: { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric', }, }, ], columnSorting: true, filters: true, dropdownMenu: true, height: 'auto', licenseKey: 'non-commercial-and-evaluation', autoWrapRow: true, autoWrapCol: true,});
// Handle dropdown toggletrigger.addEventListener('click', () => { const isOpen = !menu.hidden;
menu.hidden = isOpen; trigger.setAttribute('aria-expanded', String(!isOpen));});
// Handle locale selectionmenu.addEventListener('click', (e) => { const item = (e.target as HTMLElement).closest('li[data-value]') as HTMLLIElement | null;
if (item) { label.textContent = item.textContent!.trim(); menu.querySelectorAll('li').forEach((li) => li.setAttribute('aria-selected', 'false')); item.setAttribute('aria-selected', 'true'); menu.hidden = true; trigger.setAttribute('aria-expanded', 'false'); hot.updateSettings({ locale: item.dataset.value }); }});
// Close dropdown when clicking outsidedocument.addEventListener('click', (e) => { if (!dropdown.contains(e.target as Node)) { menu.hidden = true; trigger.setAttribute('aria-expanded', 'false'); }});
// Close dropdown on Escape keydocument.addEventListener('keydown', (e) => { if (e.key === 'Escape' && !menu.hidden) { menu.hidden = true; trigger.setAttribute('aria-expanded', 'false'); trigger.focus(); }});<div class="example-controls-container"> <div class="controls"> <div class="theme-dropdown" id="localeDropdown"> <button class="theme-dropdown-trigger" id="localeTrigger" type="button" aria-haspopup="listbox" aria-expanded="false"> <span id="localeLabel">English (United States)</span> <svg class="theme-dropdown-chevron" aria-hidden="true" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><path d="M6 9l6 6l6 -6"/></svg> </button> <ul class="theme-dropdown-menu" id="localeMenu" role="listbox" hidden> <li role="option" data-value="ar-AR">Arabic (Global)</li> <li role="option" data-value="cs-CZ">Czech (Czechia)</li> <li role="option" data-value="de-CH">German (Switzerland)</li> <li role="option" data-value="de-DE">German (Germany)</li> <li role="option" data-value="en-US" aria-selected="true">English (United States)</li> <li role="option" data-value="es-MX">Spanish (Mexico)</li> <li role="option" data-value="fa-IR">Persian (Iran)</li> <li role="option" data-value="fr-FR">French (France)</li> <li role="option" data-value="hr-HR">Croatian (Croatia)</li> <li role="option" data-value="it-IT">Italian (Italy)</li> <li role="option" data-value="ja-JP">Japanese (Japan)</li> <li role="option" data-value="ko-KR">Korean (Korea)</li> <li role="option" data-value="lv-LV">Latvian (Latvia)</li> <li role="option" data-value="nb-NO">Norwegian Bokmal (Norway)</li> <li role="option" data-value="nl-NL">Dutch (Netherlands)</li> <li role="option" data-value="pl-PL">Polish (Poland)</li> <li role="option" data-value="pt-BR">Portuguese (Brazil)</li> <li role="option" data-value="ru-RU">Russian (Russia)</li> <li role="option" data-value="sr-SP">Serbian Latin (Serbia)</li> <li role="option" data-value="zh-CN">Chinese (Simplified, China)</li> <li role="option" data-value="zh-TW">Chinese (Traditional, Taiwan)</li> </ul> </div> </div></div>
<div id="example1"></div>Use the date cell type
Use the object-style configuration by setting the type option to 'intl-date' and dateFormat to an object (recommended). The locale is controlled via the locale option.
// set the date cell type for the entire grid (Intl, recommended)type: 'intl-date',locale: 'en-US',dateFormat: { year: 'numeric', month: '2-digit', day: '2-digit'},
// set the date cell type for a single columncolumns: [ { type: 'intl-date', locale: 'en-US', dateFormat: { dateStyle: 'short' } }],
// set the date cell type for a single cellcell: [ { row: 0, col: 2, type: 'intl-date', locale: 'en-US', dateFormat: { dateStyle: 'medium' } }],For intl-date cells, source data must be in ISO 8601 date format (YYYY-MM-DD) for dates to work correctly. The dateFormat object only affects how dates are displayed; sorting and filtering rely on the underlying ISO value.
Format dates
To control how dates are displayed in cell renderers, use the dateFormat option.
Since Handsontable 17.0, the recommended approach is the object form of dateFormat with the intl-date cell type, which uses the native Intl.DateTimeFormat API. The locale is controlled separately via the locale option.
Using Intl.DateTimeFormat (recommended)
The dateFormat option accepts all properties of Intl.DateTimeFormat options. Use it with type: 'intl-date'.
columns: [ { type: 'intl-date', locale: 'en-US', dateFormat: { year: 'numeric', month: '2-digit', day: '2-digit' } }, { type: 'intl-date', locale: 'de-DE', dateFormat: { dateStyle: 'long' } }]Date-specific options
Style shortcuts:
| Property | Possible values | Description |
|---|---|---|
dateStyle | 'full', 'long', 'medium', 'short' | Date formatting style (weekday, day, month, year, era) |
timeStyle | 'full', 'long', 'medium', 'short' | Time part style (hour, minute, second, timeZoneName); use for date+time |
Date-time component options:
| Property | Possible values | Description |
|---|---|---|
weekday | 'long', 'short', 'narrow' | Weekday representation |
era | 'long', 'short', 'narrow' | Era representation |
year | 'numeric', '2-digit' | Year representation |
month | 'numeric', '2-digit', 'long', 'short', 'narrow' | Month representation |
day | 'numeric', '2-digit' | Day representation |
dayPeriod | 'narrow', 'short', 'long' | Day period (e.g. “am”) |
hour | 'numeric', '2-digit' | Hour (if time included) |
minute | 'numeric', '2-digit' | Minute |
second | 'numeric', '2-digit' | Second |
fractionalSecondDigits | 1, 2, 3 | Fraction-of-second digits |
timeZoneName | 'long', 'short', 'shortOffset', 'longOffset', 'shortGeneric', 'longGeneric' | Time zone display |
Locale and other options:
| Property | Possible values | Description |
|---|---|---|
localeMatcher | 'best fit' (default), 'lookup' | Locale matching algorithm |
calendar | 'chinese', 'gregory', 'persian', etc. | Calendar to use |
numberingSystem | 'latn', 'arab', 'hans', etc. | Numbering system |
timeZone | IANA time zone (e.g. 'UTC', 'America/New_York') | Time zone for formatting |
hour12 | true, false | 12-hour vs 24-hour time |
hourCycle | 'h11', 'h12', 'h23', 'h24' | Hour cycle |
formatMatcher | 'basic', 'best fit' (default) | Format matching algorithm |
For a complete reference, see the dateFormat API documentation or MDN: Intl.DateTimeFormat.
Using string format with Moment.js (deprecated)
The date cell type with a string dateFormat is still supported but will be removed in next major release.
Deprecated options:
| Option | Description | Replacement |
|---|---|---|
dateFormat (string) | Moment.js format (e.g. 'DD/MM/YYYY') | Use intl-date with dateFormat object (see above) |
correctFormat | Auto-correct entered date to match format | May be handled by valueParser and/or valueSetter options |
datePickerConfig | Pikaday options for the date picker | intl-date uses a native date picker; no direct equivalent |
Migration example:
// Before (deprecated)columns: [{ type: 'date', dateFormat: 'YYYY-MM-DD',}]
// After (recommended)columns: [{ type: 'intl-date', locale: 'en-US', dateFormat: { year: 'numeric', month: '2-digit', day: '2-digit', }}]Editor behavior
The dateFormat option controls how dates are displayed in the cell. The editor (date picker or text input) may show the value in a normalized form; for intl-date, the underlying value remains in ISO 8601 format.
Result
After configuring the date cell type, cells display dates formatted according to your dateFormat configuration. Clicking an intl-date cell opens a native date picker. Source data is stored in ISO 8601 format (YYYY-MM-DD) regardless of the display format.
Related articles
Related guides
Configuration options
Core methods
Hooks

Angular Data GridDate cell type

Use the date cell type to display, format, and validate date values. Pick a date using an interactive pop-up editor.

Usage

To set the date cell type, use the option type: 'date' in the columns array or cells function. The date cell uses Pikaday datepicker (opens new window) as the UI control. Pikaday uses Moment.js (opens new window) as a date formatter.

Note that date cell requires additional modules :

<script src="https://cdn.jsdelivr.net/npm/moment@2.29.4/moment.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/@handsontable/pikaday@1.0.0/pikaday.min.js"></script>

Date format

date cells accept strings that are formatted in line with the dateFormat setting.

The default date format is 'DD/MM/YYYY'.

Handsontable doesn't support JavaScript's Date object.

Change the date format

To change the date format accepted by date cells, set the dateFormat configuration option to a string with your preferred format. For example:

settings = {
  dateFormat: "YYYY-MM-DD",
};

Autocorrect invalid dates

By default, when the user enters a date in a format that doesn't match the dateFormat setting, the date is treated as invalid.

You can let Handsontable correct such dates automatically, so they match the required format. To do this, set the correctFormat option to true. For example:

settings = {
  dateFormat: "YYYY-MM-DD",
  // default behavior
  // date entered as `30/12/2022` will be invalid
  correctFormat: false,
};
settings = {
  dateFormat: "YYYY-MM-DD",
  // date entered as `30/12/2022` will be corrected to `2022/12/30`
  correctFormat: true,
};

Basic example

Click on one of the ▼ icons to open an interactive date editor.

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from '@handsontable/angular-wrapper';

@Component({
  selector: 'example1-date-cell-type',
  standalone: false,
  template: ` <div>
    <hot-table [data]="data" [settings]="gridSettings"></hot-table>
  </div>`,
})
export class Example1DateCellTypeComponent {

  readonly data = [
    ['Mercedes', 'A 160', '01/14/2021', 6999.95],
    ['Citroen', 'C4 Coupe', '12/01/2022', 8330],
    ['Audi', 'A4 Avant', '11/19/2023', 33900],
    ['Opel', 'Astra', '02/02/2021', 7000],
    ['BMW', '320i Coupe', '07/24/2022', 30500],
  ];

  readonly gridSettings: GridSettings = {
    colHeaders: ['Car', 'Model', 'Registration date', 'Price'],
    height: 'auto',
    autoWrapRow: true,
    autoWrapCol: true,
    columns: [
      {
        type: 'text',
      },
      {
        // 2nd cell is simple text, no special options here
      },
      {
        type: 'date',
        dateFormat: 'MM/DD/YYYY',
        correctFormat: true,
        defaultDate: '01/01/2020',
        // datePicker additional options
        // (see https://github.com/dbushell/Pikaday#configuration)
        datePickerConfig: {
          // First day of the week (0: Sunday, 1: Monday, etc)
          firstDay: 0,
          showWeekNumber: true,
          disableDayFn(date) {
            // Disable Sunday and Saturday
            return date.getDay() === 0 || date.getDay() === 6;
          },
        },
      },
      {
        type: 'numeric',
        numericFormat: {
          pattern: '$ 0,0.00',
        },
      },
    ]
  };
}




/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example1DateCellTypeComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example1DateCellTypeComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example1DateCellTypeComponent ]
})

export class AppModule { }

Skip to content

Display, format, sort, and filter dates correctly by using the date cell type.

The date cell type provides a date picker for selecting and displaying dates. It validates input against a configurable date format.

Overview

The date cell type lets you treat cell values as dates: format how they are displayed, validate input, and use an interactive date picker in the editor. Handsontable supports two configurations: the object-style configuration using the native Intl.DateTimeFormat API (recommended), and a string-style configuration using Moment.js (deprecated).

Date cell type demo

In the following demo, multiple columns use the date cell type with different formatting styles:

  • Product date: Date with short style formatting
  • Payment date: Customized date formatting
  • Registration date: Customized date formatting with weekday, month, day, year
Vue
<script setup lang="ts">
import { ref, onMounted, onBeforeUnmount, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
// register Handsontable's modules
registerAllModules();
const localeOptions = [
{ value: 'ar-AR', label: 'Arabic (Global)' },
{ value: 'cs-CZ', label: 'Czech (Czechia)' },
{ value: 'de-CH', label: 'German (Switzerland)' },
{ value: 'de-DE', label: 'German (Germany)' },
{ value: 'en-US', label: 'English (United States)' },
{ value: 'es-MX', label: 'Spanish (Mexico)' },
{ value: 'fa-IR', label: 'Persian (Iran)' },
{ value: 'fr-FR', label: 'French (France)' },
{ value: 'hr-HR', label: 'Croatian (Croatia)' },
{ value: 'it-IT', label: 'Italian (Italy)' },
{ value: 'ja-JP', label: 'Japanese (Japan)' },
{ value: 'ko-KR', label: 'Korean (Korea)' },
{ value: 'lv-LV', label: 'Latvian (Latvia)' },
{ value: 'nb-NO', label: 'Norwegian Bokmal (Norway)' },
{ value: 'nl-NL', label: 'Dutch (Netherlands)' },
{ value: 'pl-PL', label: 'Polish (Poland)' },
{ value: 'pt-BR', label: 'Portuguese (Brazil)' },
{ value: 'ru-RU', label: 'Russian (Russia)' },
{ value: 'sr-SP', label: 'Serbian Latin (Serbia)' },
{ value: 'zh-CN', label: 'Chinese (Simplified, China)' },
{ value: 'zh-TW', label: 'Chinese (Traditional, Taiwan)' },
];
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const dropdownRef = useTemplateRef<HTMLDivElement>('dropdownRef');
const isOpen = ref(false);
const locale = ref('en-US');
const selectedLabel = () => localeOptions.find((o) => o.value === locale.value)?.label;
const handleSelect = (value: string) => {
locale.value = value;
isOpen.value = false;
hotRef.value?.hotInstance?.updateSettings({ locale: value } as GridSettings);
};
const handleOutsideClick = (e: MouseEvent) => {
if (dropdownRef.value && !dropdownRef.value.contains(e.target as Node)) {
isOpen.value = false;
}
};
const handleEscape = (e: KeyboardEvent) => {
if (e.key === 'Escape') {
isOpen.value = false;
}
};
onMounted(() => {
document.addEventListener('click', handleOutsideClick);
document.addEventListener('keydown', handleEscape);
});
onBeforeUnmount(() => {
document.removeEventListener('click', handleOutsideClick);
document.removeEventListener('keydown', handleEscape);
});
const data = [
{
car: 'Mercedes A 160',
product_date: '2002-06-15',
payment_date: '2002-05-20',
registration_date: '2002-07-01',
},
{
car: 'Citroën C4 Coupe',
product_date: '2007-03-22',
payment_date: '2007-02-28',
registration_date: '2007-04-10',
},
{
car: 'Audi A4 Avant',
product_date: '2011-09-08',
payment_date: '2011-08-15',
registration_date: '2011-09-20',
},
{
car: 'Opel Astra',
product_date: '2012-01-30',
payment_date: '2012-01-10',
registration_date: '2012-02-14',
},
{
car: 'BMW 320i Coupe',
product_date: '2004-11-12',
payment_date: '2004-10-20',
registration_date: '2004-12-01',
},
];
const hotSettings = ref<GridSettings>({
data,
colHeaders: ['Car', 'Product date', 'Payment date', 'Registration date'],
locale: 'en-US',
columns: [
{
type: 'text',
data: 'car',
},
{
type: 'intl-date',
data: 'product_date',
dateFormat: { dateStyle: 'short' },
},
{
type: 'intl-date',
data: 'payment_date',
dateFormat: {
month: 'long',
day: 'numeric',
year: 'numeric',
},
},
{
type: 'intl-date',
data: 'registration_date',
dateFormat: {
weekday: 'long',
year: 'numeric',
month: 'long',
day: 'numeric',
},
},
],
columnSorting: true,
filters: true,
dropdownMenu: true,
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example1">
<div class="example-controls-container">
<div class="controls">
<div class="theme-dropdown" ref="dropdownRef">
<button
class="theme-dropdown-trigger"
type="button"
aria-haspopup="listbox"
:aria-expanded="isOpen"
@click="isOpen = !isOpen"
>
<span>{{ selectedLabel() }}</span>
<svg class="theme-dropdown-chevron" aria-hidden="true" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><path d="M6 9l6 6l6 -6"/></svg>
</button>
<ul v-if="isOpen" class="theme-dropdown-menu" role="listbox">
<li
v-for="opt in localeOptions"
:key="opt.value"
role="option"
:aria-selected="locale === opt.value"
@click="handleSelect(opt.value)"
>
{{ opt.label }}
</li>
</ul>
</div>
</div>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Use the date cell type

Use the object-style configuration by setting the type option to 'intl-date' and dateFormat to an object (recommended). The locale is controlled via the locale option.

// set the date cell type for the entire grid (Intl, recommended)
const hotSettings = ref({
type: 'intl-date',
locale: 'en-US',
dateFormat: {
year: 'numeric',
month: '2-digit',
day: '2-digit'
}
});
// set the date cell type for a single column
const hotSettings = ref({
columns: [
{
type: 'intl-date',
locale: 'en-US',
dateFormat: { dateStyle: 'short' }
}
]
});
// set the date cell type for a single cell
const hotSettings = ref({
cell: [
{
row: 0,
col: 2,
type: 'intl-date',
locale: 'en-US',
dateFormat: { dateStyle: 'medium' }
}
]
});

For intl-date cells, source data must be in ISO 8601 date format (YYYY-MM-DD) for dates to work correctly. The dateFormat object only affects how dates are displayed; sorting and filtering rely on the underlying ISO value.

Format dates

To control how dates are displayed in cell renderers, use the dateFormat option.

Since Handsontable 17.0, the recommended approach is the object form of dateFormat with the intl-date cell type, which uses the native Intl.DateTimeFormat API. The locale is controlled separately via the locale option.

The dateFormat option accepts all properties of Intl.DateTimeFormat options. Use it with type: 'intl-date'.

const hotSettings = ref({
columns: [
{
type: 'intl-date',
locale: 'en-US',
dateFormat: {
year: 'numeric',
month: '2-digit',
day: '2-digit'
}
},
{
type: 'intl-date',
locale: 'de-DE',
dateFormat: { dateStyle: 'long' }
}
]
});

Date-specific options

Style shortcuts:

PropertyPossible valuesDescription
dateStyle'full', 'long', 'medium', 'short'Date formatting style (weekday, day, month, year, era)
timeStyle'full', 'long', 'medium', 'short'Time part style (hour, minute, second, timeZoneName); use for date+time

Date-time component options:

PropertyPossible valuesDescription
weekday'long', 'short', 'narrow'Weekday representation
era'long', 'short', 'narrow'Era representation
year'numeric', '2-digit'Year representation
month'numeric', '2-digit', 'long', 'short', 'narrow'Month representation
day'numeric', '2-digit'Day representation
dayPeriod'narrow', 'short', 'long'Day period (e.g. “am”)
hour'numeric', '2-digit'Hour (if time included)
minute'numeric', '2-digit'Minute
second'numeric', '2-digit'Second
fractionalSecondDigits1, 2, 3Fraction-of-second digits
timeZoneName'long', 'short', 'shortOffset', 'longOffset', 'shortGeneric', 'longGeneric'Time zone display

Locale and other options:

PropertyPossible valuesDescription
localeMatcher'best fit' (default), 'lookup'Locale matching algorithm
calendar'chinese', 'gregory', 'persian', etc.Calendar to use
numberingSystem'latn', 'arab', 'hans', etc.Numbering system
timeZoneIANA time zone (e.g. 'UTC', 'America/New_York')Time zone for formatting
hour12true, false12-hour vs 24-hour time
hourCycle'h11', 'h12', 'h23', 'h24'Hour cycle
formatMatcher'basic', 'best fit' (default)Format matching algorithm

For a complete reference, see the dateFormat API documentation or MDN: Intl.DateTimeFormat.

Using string format with Moment.js (deprecated)

The date cell type with a string dateFormat is still supported but will be removed in next major release.

Deprecated options:

OptionDescriptionReplacement
dateFormat (string)Moment.js format (e.g. 'DD/MM/YYYY')Use intl-date with dateFormat object (see above)
correctFormatAuto-correct entered date to match formatMay be handled by valueParser and/or valueSetter options
datePickerConfigPikaday options for the date pickerintl-date uses a native date picker; no direct equivalent

Migration example:

// Before (deprecated)
columns: [{
type: 'date',
dateFormat: 'YYYY-MM-DD',
}]
// After (recommended)
columns: [{
type: 'intl-date',
locale: 'en-US',
dateFormat: {
year: 'numeric',
month: '2-digit',
day: '2-digit',
}
}]

Editor behavior

The dateFormat option controls how dates are displayed in the cell. The editor (date picker or text input) may show the value in a normalized form; for intl-date, the underlying value remains in ISO 8601 format.

Result

After configuring the date cell type, cells display dates formatted according to your dateFormat configuration. Clicking an intl-date cell opens a native date picker. Source data is stored in ISO 8601 format (YYYY-MM-DD) regardless of the display format.

Related guides

Configuration options

Core methods

Hooks

Date cell type
Display, format, sort, and filter dates correctly by using the date cell type.
The date cell type provides a date picker for selecting and displaying dates. It validates input against a configurable date format.
Overview
The date cell type lets you treat cell values as dates: format how they are displayed, validate input, and use an interactive date picker in the editor. Handsontable supports two configurations: the object-style configuration using the native Intl.DateTimeFormat API (recommended), and a string-style configuration using Moment.js (deprecated).
Date cell type demo
In the following demo, multiple columns use the date cell type with different formatting styles:
- Product date: Date with short style formatting
- Payment date: Customized date formatting
- Registration date: Customized date formatting with weekday, month, day, year
import { useRef, useState, useEffect } from 'react';import { HotTable } from '@handsontable/react-wrapper';import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modulesregisterAllModules();
23 collapsed lines
const localeOptions = [ { value: 'ar-AR', label: 'Arabic (Global)' }, { value: 'cs-CZ', label: 'Czech (Czechia)' }, { value: 'de-CH', label: 'German (Switzerland)' }, { value: 'de-DE', label: 'German (Germany)' }, { value: 'en-US', label: 'English (United States)' }, { value: 'es-MX', label: 'Spanish (Mexico)' }, { value: 'fa-IR', label: 'Persian (Iran)' }, { value: 'fr-FR', label: 'French (France)' }, { value: 'hr-HR', label: 'Croatian (Croatia)' }, { value: 'it-IT', label: 'Italian (Italy)' }, { value: 'ja-JP', label: 'Japanese (Japan)' }, { value: 'ko-KR', label: 'Korean (Korea)' }, { value: 'lv-LV', label: 'Latvian (Latvia)' }, { value: 'nb-NO', label: 'Norwegian Bokmal (Norway)' }, { value: 'nl-NL', label: 'Dutch (Netherlands)' }, { value: 'pl-PL', label: 'Polish (Poland)' }, { value: 'pt-BR', label: 'Portuguese (Brazil)' }, { value: 'ru-RU', label: 'Russian (Russia)' }, { value: 'sr-SP', label: 'Serbian Latin (Serbia)' }, { value: 'zh-CN', label: 'Chinese (Simplified, China)' }, { value: 'zh-TW', label: 'Chinese (Traditional, Taiwan)' },];
const ExampleComponent = () => { const hotRef = useRef(null); const dropdownRef = useRef(null); const [isOpen, setIsOpen] = useState(false); const [locale, setLocale] = useState('en-US');
useEffect(() => { const handleOutsideClick = (e) => { if (dropdownRef.current && !dropdownRef.current.contains(e.target)) { setIsOpen(false); } }; const handleEscape = (e) => { if (e.key === 'Escape') { setIsOpen(false); } };
document.addEventListener('click', handleOutsideClick); document.addEventListener('keydown', handleEscape);
return () => { document.removeEventListener('click', handleOutsideClick); document.removeEventListener('keydown', handleEscape); }; }, []);
const handleSelect = (value) => { setLocale(value); setIsOpen(false); hotRef.current?.hotInstance?.updateSettings({ locale: value }); };
const selectedLabel = localeOptions.find((o) => o.value === locale)?.label;
32 collapsed lines
const data = [ { car: 'Mercedes A 160', product_date: '2002-06-15', payment_date: '2002-05-20', registration_date: '2002-07-01', }, { car: 'Citroën C4 Coupe', product_date: '2007-03-22', payment_date: '2007-02-28', registration_date: '2007-04-10', }, { car: 'Audi A4 Avant', product_date: '2011-09-08', payment_date: '2011-08-15', registration_date: '2011-09-20', }, { car: 'Opel Astra', product_date: '2012-01-30', payment_date: '2012-01-10', registration_date: '2012-02-14', }, { car: 'BMW 320i Coupe', product_date: '2004-11-12', payment_date: '2004-10-20', registration_date: '2004-12-01', }, ];
return ( <> <div className="example-controls-container"> <div className="controls"> <div className="theme-dropdown" ref={dropdownRef}> <button className="theme-dropdown-trigger" type="button" aria-haspopup="listbox" aria-expanded={isOpen} onClick={() => setIsOpen(!isOpen)} > <span>{selectedLabel}</span> <svg className="theme-dropdown-chevron" aria-hidden="true" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" strokeWidth="2" strokeLinecap="round" strokeLinejoin="round"><path d="M6 9l6 6l6 -6"/></svg> </button> {isOpen && ( <ul className="theme-dropdown-menu" role="listbox"> {localeOptions.map((opt) => ( <li key={opt.value} role="option" aria-selected={locale === opt.value} onClick={() => handleSelect(opt.value)} > {opt.label} </li> ))} </ul> )} </div> </div> </div>
<HotTable ref={hotRef} data={data} colHeaders={['Car', 'Product date', 'Payment date', 'Registration date']} locale={locale}30 collapsed lines
columns={[ { type: 'text', data: 'car', }, { type: 'intl-date', data: 'product_date', dateFormat: { dateStyle: 'short' }, }, { type: 'intl-date', data: 'payment_date', dateFormat: { month: 'long', day: 'numeric', year: 'numeric', }, }, { type: 'intl-date', data: 'registration_date', dateFormat: { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric', }, }, ]} columnSorting={true} filters={true} dropdownMenu={true} height="auto" autoWrapRow={true} autoWrapCol={true} licenseKey="non-commercial-and-evaluation" /> </> );};
export default ExampleComponent;import { useRef, useState, useEffect } from 'react';import Handsontable from 'handsontable/base';import { HotTable, HotTableRef } from '@handsontable/react-wrapper';import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modulesregisterAllModules();
23 collapsed lines
const localeOptions: { value: string; label: string }[] = [ { value: 'ar-AR', label: 'Arabic (Global)' }, { value: 'cs-CZ', label: 'Czech (Czechia)' }, { value: 'de-CH', label: 'German (Switzerland)' }, { value: 'de-DE', label: 'German (Germany)' }, { value: 'en-US', label: 'English (United States)' }, { value: 'es-MX', label: 'Spanish (Mexico)' }, { value: 'fa-IR', label: 'Persian (Iran)' }, { value: 'fr-FR', label: 'French (France)' }, { value: 'hr-HR', label: 'Croatian (Croatia)' }, { value: 'it-IT', label: 'Italian (Italy)' }, { value: 'ja-JP', label: 'Japanese (Japan)' }, { value: 'ko-KR', label: 'Korean (Korea)' }, { value: 'lv-LV', label: 'Latvian (Latvia)' }, { value: 'nb-NO', label: 'Norwegian Bokmal (Norway)' }, { value: 'nl-NL', label: 'Dutch (Netherlands)' }, { value: 'pl-PL', label: 'Polish (Poland)' }, { value: 'pt-BR', label: 'Portuguese (Brazil)' }, { value: 'ru-RU', label: 'Russian (Russia)' }, { value: 'sr-SP', label: 'Serbian Latin (Serbia)' }, { value: 'zh-CN', label: 'Chinese (Simplified, China)' }, { value: 'zh-TW', label: 'Chinese (Traditional, Taiwan)' },];
const ExampleComponent = () => { const hotRef = useRef<HotTableRef>(null); const dropdownRef = useRef<HTMLDivElement>(null); const [isOpen, setIsOpen] = useState(false); const [locale, setLocale] = useState('en-US');
useEffect(() => { const handleOutsideClick = (e: MouseEvent) => { if (dropdownRef.current && !dropdownRef.current.contains(e.target as Node)) { setIsOpen(false); } }; const handleEscape = (e: KeyboardEvent) => { if (e.key === 'Escape') { setIsOpen(false); } };
document.addEventListener('click', handleOutsideClick); document.addEventListener('keydown', handleEscape);
return () => { document.removeEventListener('click', handleOutsideClick); document.removeEventListener('keydown', handleEscape); }; }, []);
const handleSelect = (value: string) => { setLocale(value); setIsOpen(false); hotRef.current?.hotInstance?.updateSettings({ locale: value } as Handsontable.GridSettings); };
const selectedLabel = localeOptions.find((o) => o.value === locale)?.label;
32 collapsed lines
const data = [ { car: 'Mercedes A 160', product_date: '2002-06-15', payment_date: '2002-05-20', registration_date: '2002-07-01', }, { car: 'Citroën C4 Coupe', product_date: '2007-03-22', payment_date: '2007-02-28', registration_date: '2007-04-10', }, { car: 'Audi A4 Avant', product_date: '2011-09-08', payment_date: '2011-08-15', registration_date: '2011-09-20', }, { car: 'Opel Astra', product_date: '2012-01-30', payment_date: '2012-01-10', registration_date: '2012-02-14', }, { car: 'BMW 320i Coupe', product_date: '2004-11-12', payment_date: '2004-10-20', registration_date: '2004-12-01', }, ];
return ( <> <div className="example-controls-container"> <div className="controls"> <div className="theme-dropdown" ref={dropdownRef}> <button className="theme-dropdown-trigger" type="button" aria-haspopup="listbox" aria-expanded={isOpen} onClick={() => setIsOpen(!isOpen)} > <span>{selectedLabel}</span> <svg className="theme-dropdown-chevron" aria-hidden="true" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" strokeWidth="2" strokeLinecap="round" strokeLinejoin="round"><path d="M6 9l6 6l6 -6"/></svg> </button> {isOpen && ( <ul className="theme-dropdown-menu" role="listbox"> {localeOptions.map((opt) => ( <li key={opt.value} role="option" aria-selected={locale === opt.value} onClick={() => handleSelect(opt.value)} > {opt.label} </li> ))} </ul> )} </div> </div> </div>
<HotTable ref={hotRef} data={data} colHeaders={['Car', 'Product date', 'Payment date', 'Registration date']} locale={locale}30 collapsed lines
columns={[ { type: 'text', data: 'car', }, { type: 'intl-date', data: 'product_date', dateFormat: { dateStyle: 'short' }, }, { type: 'intl-date', data: 'payment_date', dateFormat: { month: 'long', day: 'numeric', year: 'numeric', }, }, { type: 'intl-date', data: 'registration_date', dateFormat: { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric', }, }, ]} columnSorting={true} filters={true} dropdownMenu={true} height="auto" autoWrapRow={true} autoWrapCol={true} licenseKey="non-commercial-and-evaluation" /> </> );};
export default ExampleComponent;Use the date cell type
Use the object-style configuration by setting the type option to 'intl-date' and dateFormat to an object (recommended). The locale is controlled via the locale option.
// set the date cell type for the entire grid (Intl, recommended)type="intl-date"locale="en-US"dateFormat={{ year: 'numeric', month: '2-digit', day: '2-digit'}}
// set the date cell type for a single columncolumns={[{ type: 'intl-date', locale: 'en-US', dateFormat: { dateStyle: 'short' }}]}
// set the date cell type for a single cellcell={[{ row: 0, col: 2, type: 'intl-date', locale: 'en-US', dateFormat: { dateStyle: 'medium' }}]}For intl-date cells, source data must be in ISO 8601 date format (YYYY-MM-DD) for dates to work correctly. The dateFormat object only affects how dates are displayed; sorting and filtering rely on the underlying ISO value.
Format dates
To control how dates are displayed in cell renderers, use the dateFormat option.
Since Handsontable 17.0, the recommended approach is the object form of dateFormat with the intl-date cell type, which uses the native Intl.DateTimeFormat API. The locale is controlled separately via the locale option.
Using Intl.DateTimeFormat (recommended)
The dateFormat option accepts all properties of Intl.DateTimeFormat options. Use it with type: 'intl-date'.
<HotTable columns={[{ type: 'intl-date', locale: 'en-US', dateFormat: { year: 'numeric', month: '2-digit', day: '2-digit' } }, { type: 'intl-date', locale: 'de-DE', dateFormat: { dateStyle: 'long' } }]}/>Date-specific options
Style shortcuts:
| Property | Possible values | Description |
|---|---|---|
dateStyle | 'full', 'long', 'medium', 'short' | Date formatting style (weekday, day, month, year, era) |
timeStyle | 'full', 'long', 'medium', 'short' | Time part style (hour, minute, second, timeZoneName); use for date+time |
Date-time component options:
| Property | Possible values | Description |
|---|---|---|
weekday | 'long', 'short', 'narrow' | Weekday representation |
era | 'long', 'short', 'narrow' | Era representation |
year | 'numeric', '2-digit' | Year representation |
month | 'numeric', '2-digit', 'long', 'short', 'narrow' | Month representation |
day | 'numeric', '2-digit' | Day representation |
dayPeriod | 'narrow', 'short', 'long' | Day period (e.g. “am”) |
hour | 'numeric', '2-digit' | Hour (if time included) |
minute | 'numeric', '2-digit' | Minute |
second | 'numeric', '2-digit' | Second |
fractionalSecondDigits | 1, 2, 3 | Fraction-of-second digits |
timeZoneName | 'long', 'short', 'shortOffset', 'longOffset', 'shortGeneric', 'longGeneric' | Time zone display |
Locale and other options:
| Property | Possible values | Description |
|---|---|---|
localeMatcher | 'best fit' (default), 'lookup' | Locale matching algorithm |
calendar | 'chinese', 'gregory', 'persian', etc. | Calendar to use |
numberingSystem | 'latn', 'arab', 'hans', etc. | Numbering system |
timeZone | IANA time zone (e.g. 'UTC', 'America/New_York') | Time zone for formatting |
hour12 | true, false | 12-hour vs 24-hour time |
hourCycle | 'h11', 'h12', 'h23', 'h24' | Hour cycle |
formatMatcher | 'basic', 'best fit' (default) | Format matching algorithm |
For a complete reference, see the dateFormat API documentation or MDN: Intl.DateTimeFormat.
Using string format with Moment.js (deprecated)
The date cell type with a string dateFormat is still supported but will be removed in next major release.
Deprecated options:
| Option | Description | Replacement |
|---|---|---|
dateFormat (string) | Moment.js format (e.g. 'DD/MM/YYYY') | Use intl-date with dateFormat object (see above) |
correctFormat | Auto-correct entered date to match format | May be handled by valueParser and/or valueSetter options |
datePickerConfig | Pikaday options for the date picker | intl-date uses a native date picker; no direct equivalent |
Migration example:
// Before (deprecated)columns: [{ type: 'date', dateFormat: 'YYYY-MM-DD',}]
// After (recommended)columns: [{ type: 'intl-date', locale: 'en-US', dateFormat: { year: 'numeric', month: '2-digit', day: '2-digit', }}]Editor behavior
The dateFormat option controls how dates are displayed in the cell. The editor (date picker or text input) may show the value in a normalized form; for intl-date, the underlying value remains in ISO 8601 format.
Result
After configuring the date cell type, cells display dates formatted according to your dateFormat configuration. Clicking an intl-date cell opens a native date picker. Source data is stored in ISO 8601 format (YYYY-MM-DD) regardless of the display format.
Related articles
Related guides
Configuration options
Core methods
Hooks